workflow:
  rules:
    - if: $CI_PIPELINE_SOURCE == "schedule"
      when: always
    - if: $CI_PIPELINE_SOURCE == "web"
      when: always
    - if: $CI_COMMIT_BRANCH && $CI_OPEN_MERGE_REQUESTS && $CI_PIPELINE_SOURCE == "push"
      when: never
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"
    - if: $CI_COMMIT_BRANCH && $CI_OPEN_MERGE_REQUESTS
      when: never
    - if: $CI_COMMIT_BRANCH

include: 'https://gitlab.com/nomadic-labs/gitlab-ocaml-ci-example/-/raw/main/.gitlab-ci.yml'

.build-matrix:
  parallel:
    matrix:
    - OCAML_COMPILER: ["4.12.1", "4.13.1", "4.14.0"]
      DUNE_BUILD_TARGETS: "@all"
      DUNE_TEST_TARGETS: "@runtest @fmt"
      DUNE_DOC_TARGETS: [""]

variables:
  # The cache causes conf-* packages to not be reinstalled,
  # which in turn causes system dependencies to not be installed,
  # which in turn causes node to not be installed,
  # which in turn causes JS tests to fail.
  # A better solution could be to improve the .gitlab-ci.yml template
  # to not cache conf-* packages, so that other packages can still be cached.
  CLEAN_OPAM_CACHE: "true"
  CLEAN_DUNE_CACHE: "false"
